<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Traits\TQuery;

class FindFactory
{

    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function findOperador($filtro)
    {

        $sql = "SELECT CDOPERADOR, NMOPERADOR
         FROM OPERADOR
        WHERE IDATIVO = 'S' 
          AND IDOPERATIVO = 'A'
          AND " . $filtro . "
        ORDER BY NMOPERADOR";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function findTipoSolicitacao()
    {
        $sql = "SELECT NRTIPOSOLICITACAO, NMTIPOSOLICITACAO
                    FROM FCM_TIPOSOLICITACAO
                    WHERE IDATIVO = 'S'
                    ORDER BY NMTIPOSOLICITACAO";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function findOperadorHierarq($filtro, $listaLocais)
    {
        $sql = "SELECT DISTINCT OPERADOR.CDOPERADOR, OPERADOR.NMOPERADOR, FCM_RELACHABOPER.NRHABILIDADE
                    FROM OPERADOR
                    JOIN FCM_FUNCIONARIOSHIERARQ
                    ON FCM_FUNCIONARIOSHIERARQ.CDOPERADOR = OPERADOR.CDOPERADOR
                    JOIN FCM_HIERARQUIAFUNC
                    ON FCM_HIERARQUIAFUNC.NRHIERARQUIAFUNC = FCM_FUNCIONARIOSHIERARQ.NRHIERARQUIAFUNC
                    JOIN FCM_RELACHABOPER
                    ON FCM_RELACHABOPER.CDOPERADOR = OPERADOR.CDOPERADOR
                    WHERE FCM_HIERARQUIAFUNC.NRLOCALCLIENTE IN (SELECT NRLOCALCLIENTE
                                            FROM FCM_LOCALCLI
                                            START WITH NRLOCALCLIENTE IN ($listaLocais)
                                            CONNECT BY PRIOR NRLOCALCLIENTEPAI = NRLOCALCLIENTE) 
                    AND " . $filtro . "
                    ORDER BY OPERADOR.NMOPERADOR";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function findLocal($filtro, $listaLocais)
    {
        $sql = "SELECT FCM_LOCALCLI.NRLOCALCLIENTE, FCM_LOCALCLI.NMLOCALCLIENTE
                FROM FCM_LOCALCLI
                JOIN FCM_TIPOLOCALCLI
                ON FCM_TIPOLOCALCLI.NRTIPOLOCALCLI = FCM_LOCALCLI.NRTIPOLOCALCLI
                WHERE" . $filtro . "
                AND FCM_LOCALCLI.IDATIVO = 'S'
                AND FCM_LOCALCLI.NRLOCALCLIENTE IN ($listaLocais)
                ORDER BY FCM_LOCALCLI.NMLOCALCLIENTE";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function findTipoLocal($filtro)
    {

        $sql = "SELECT NRTIPOLOCALCLI, NMTIPOLOCALCLI
                FROM FCM_TIPOLOCALCLI
                WHERE" . $filtro . "
                AND IDATIVO = 'S'
                ORDER BY NMTIPOLOCALCLI";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function findChecklist($filtro)
    {
        $sql = "SELECT NRCHECKLIST, NMCHECKLIST
                FROM FCM_CHECKLIST
                WHERE" . $filtro . "
                AND IDATIVO = 'S'
                ORDER BY NMCHECKLIST";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function findServico($filtro)
    {

        $sql = "SELECT CDSERVORCA, NMSERVORCA
                    FROM FCT_SERVICOORCA
                    WHERE" . $filtro . "
                    AND IDATIVO = 'S'
                    ORDER BY NMSERVORCA";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function findTipoMedidaSm($filtro)
    {

        $sql = "SELECT CDTPMEDIDASERV, DSTPMEDIDASERV
                    FROM FCT_TIPOMEDIDASERV
                    WHERE" . $filtro . "
                    ORDER BY DSTPMEDIDASERV";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function findItens($filtro)
    {

        $sql = "SELECT NRATIVIDADE, NMATIVIDADE 
                    FROM FCM_ATIVIDADE 
                    WHERE" . $filtro . "
                    ORDER BY NMATIVIDADE";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function findEscoposServicos($filtro)
    {

        $sql = "SELECT * FROM FCM_ESCOPOSTAREFA
                    WHERE" . $filtro . "
                    AND IDATIVO = 'S'
                    ORDER BY NMESCOPOSTAREFA";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }


    public function findAtividades($filtro)
    {

        $sql = "SELECT * FROM FCM_TAREFA
                WHERE" . $filtro . "
                AND IDATIVO = 'S'
                ORDER BY NMTAREFA";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function findItensChecklist($filtro)
    {
        
        $sql = "SELECT * FROM FCM_ATIVIDADE
                WHERE" . $filtro . "
                AND IDATIVO = 'S'
                ORDER BY NMATIVIDADE";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function findClientes($filtro)
    {

        $sql = "SELECT DISTINCT C.CDCLIENTE, C.NMRAZSOCCLIE, C.NMFANTCLIE
                    FROM FCM_LOCALCLI LC
                    JOIN CLIENTE C 
                    ON LC.CDCLIENTE = C.CDCLIENTE
                    WHERE" . $filtro . "
                    ORDER BY C.CDCLIENTE, C.NMRAZSOCCLIE, C.NMFANTCLIE";
            
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function findPrioridades($filtro)
    {

        $sql = "SELECT NRPRIORIDADETAREFA, NMPRIORIDADETAREFA, IDPRIORIDADE, ATRASOPERMITIDO
                    FROM FCM_PRIORIDADETAREFA
                    WHERE" . $filtro . "
                    ORDER BY NMPRIORIDADETAREFA";
            
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }
}
